catch {wm title . "IFT-based Multiscale Skeletons"}

wm minsize . 256 256

proc LoadImage { } {
    global filename skel_type


    set types {
	{ {Only Files} {.pgm}}
    }
    set filename [tk_getOpenFile -filetypes $types ]
#    set ext [lindex [split $filename .] 1]
#    if {[string compare $ext pgm] == 0} {
	DisplayImage $filename
	ProcessImage $filename 5 $skel_type
	CreateScale  $filename
#    } else { 
#	tk_messageBox -message "Can only handle raw (pgm) files." -type ok
#	-icon warning
#    }
}


proc CreateScale filename {
global skel_type    
	set value 5
	set min 1
	set f [open "diff.pgm" r] 
	gets $f trash 
	gets $f trash 
	gets $f max
	close $f
	set label "Threshold"
	destroy .scale 	
        scale .scale -from $min -to $max -showvalue 1 -orient horizontal -label $label 
        pack .scale -fill x -expand 1 
        bind .scale <ButtonPress-1><Motion><ButtonRelease-1> {ProcessImage $filename [.scale get ] $skel_type }
        .scale set $value	
	
	destroy .b
	button .b -text "Exit" -command {exec rm -f diff.pgm reconstr.pgm skel.pgm; exit}
	pack .b -side right -fill both -expand true

}

proc DisplayImage filename  {
    destroy .frame
    image create photo img1 -file $filename 
    set w [image width img1]
    set h [image height img1]
    frame .frame -width 2
    canvas .frame.c1 -width $w -height $h
    .frame.c1 create image [expr $w/2] [expr $h/2] -image img1 -tag Imagem1
    pack .frame.c1 -side left
    pack .frame
    bind .frame <Button-3>        {exit}
}

proc ProcessImage {filename threshold skel_type} {

set skel [format "exec skel %s %d %d" $filename $threshold $skel_type] 
eval $skel

source skel_sk.tcl
source skel_rec.tcl
}

# Menubuttons: File and Options

frame .mbar -relief raised -bd 2
menubutton .mbar.file -text File -underline 0 -menu .mbar.file.menu
menubutton .mbar.options -text Options -underline 0 -menu .mbar.options.menu
pack .mbar.file -side left
pack .mbar.options -side left
pack .mbar -fill x

# Buttons for the file menu: Open and Exit
menu .mbar.file.menu
.mbar.file.menu add command -label Open -command {LoadImage}
.mbar.file.menu add command -label Exit -command exit

# Buttons for the options menu: Full Skeleton, Inner Skeleton and Outer Skeleton
menu .mbar.options.menu
.mbar.options.menu  add radio -label "Full  Skeleton" -variable skel_type -value 0 -command {set skel_type 0; ProcessImage $filename [.scale get] $skel_type}
.mbar.options.menu  add radio -label "Inner Skeleton" -variable skel_type -value 1 -command {set skel_type 1; ProcessImage $filename [.scale get] $skel_type}
.mbar.options.menu  add radio -label "Outer Skeleton" -variable skel_type -value 2 -command {set skel_type 2; ProcessImage $filename [.scale get] $skel_type}

set skel_type 1
tk_menuBar .mbar .mbar.file .mbar.options
focus .mbar

if {$argc == 1} {
	set filename   [lindex $argv 0]
} else {
       set filename  "./figure.pgm"
}

DisplayImage $filename
ProcessImage $filename 5 $skel_type
CreateScale  $filename




